﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ModbusDemo
{
    class _418X
    {
        const int MAX_AN_CH_NUM = 8;
        ushort[] typeData = new ushort[8];//当前量程读数
        byte[] AbnoSignal = new byte[8];//通道异常信号
        ushort[] Inputtype = new ushort[8];//输入类型
        ushort[] m_u16ADData = new ushort[MAX_AN_CH_NUM];  //保存AD的值

        string[] Strcom = new string[] {"A_10V","A_5V","A_2_5V","A_1V","A_500mV",
                                        "A_100mV","A_20mV","T-K","T-J","T-R","T-S",
                                         "T-B","T_E","T_T","T_N","I_0_20mA","I_4_20mA","null"};

        string[] unit = new string[] { "null", "℃", "V", "MV", "MA" };

        public class UserInfo
        {
            public int UserId { get; set; }
            public string UserCompany { get; set; }

            public float Data { get; set; }

            public ushort UserModel { get; set; }
            public double[] NegMin = {-10.000, -5.000, -2.500, -1.000, -500.00, -100.00,
                                      -20.00, 0, 0, 0, 0, 0, 0, -100,0, -20, -20 }; //负数最小值
            public double[] NegMax = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };//负数最大值
            public double[] PosMin = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 500, 500, 500, 0, 0, 0, 0, 0 };//正数最小值
            public double[] PosMax = { 10.000, 5.000, 2.500, 1.000, 500.00, 100.00, 20.000, 1370,
                                       760, 1750, 1750, 1800 , 1000, 400,200,20,20};//正数最大值
            public ushort[] usMin = {0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000 ,
                                 0x0000, 0x0000, 0x2492, 0x2492, 0x2381, 0x0000, 0xE000,0x0000,0x8000,0x8000 };
            public ushort[] usMax = {0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF,0x0000, 0x7FFF, 0x7FFF ,
                                 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF,0x7FFF,0x7FFF,0x7FFF };
        }

        //List<UserInfo> users = new List<UserInfo>();
        UserInfo users = new UserInfo();
        UserInfo users1 = new UserInfo();
        UserInfo users2 = new UserInfo();
        UserInfo users3 = new UserInfo();
        UserInfo users4 = new UserInfo();
        UserInfo users5 = new UserInfo();
        UserInfo users6 = new UserInfo();
        UserInfo users7 = new UserInfo();

        public string[] Value(ushort[] typeData, ushort[] Inputtype)
        {
            string[] Valuepass = new string[MAX_AN_CH_NUM];
            if (typeData != null || Inputtype != null)
            {
                /********************/
                users.UserId = 0;//通道
                users.Data = typeData[0];//数据
                users.UserCompany = Strcom[Inputtype[0]];//通道类型
                users.UserModel = Inputtype[0];//确定计算公式
                                               /********************/
                users1.UserId = 1;//通道
                users1.Data = typeData[1];//数据
                users1.UserCompany = Strcom[Inputtype[1]];//通道类型
                users1.UserModel = Inputtype[1];//确定计算公式
                                                /********************/
                users2.UserId = 2;//通道
                users2.Data = typeData[2];//数据
                users2.UserCompany = Strcom[Inputtype[2]];//通道类型
                users2.UserModel = Inputtype[2];//确定计算公式
                                                /********************/
                users3.UserId = 3;//通道
                users3.Data = typeData[3];//数据
                users3.UserCompany = Strcom[Inputtype[3]];//通道类型
                users3.UserModel = Inputtype[3];//确定计算公式
                                                /********************/
                users4.UserId = 4;//通道
                users4.Data = typeData[4];//数据
                users4.UserCompany = Strcom[Inputtype[4]];//通道类型
                users4.UserModel = Inputtype[4];//确定计算公式
                                                /********************/
                users5.UserId = 5;//通道
                users5.Data = typeData[5];//数据
                users5.UserCompany = Strcom[Inputtype[5]];//通道类型
                users5.UserModel = Inputtype[5];//确定计算公式
                                                /********************/
                users6.UserId = 6;//通道
                users6.Data = typeData[6];//数据
                users6.UserCompany = Strcom[Inputtype[6]];//通道类型
                users6.UserModel = Inputtype[6];//确定计算公式
                                                /********************/
                users7.UserId = 7;//通道
                users7.Data = typeData[7];//数据
                users7.UserCompany = Strcom[Inputtype[7]];//通道类型
                users7.UserModel = Inputtype[7];//确定计算公式

                //////输入格式为：NegMin   NegMax  PosMin  PosMax usMin usMax
                Valuepass[0] = current(users.NegMin[users.UserModel], users.NegMax[users.UserModel], users.PosMin[users.UserModel],
                    users.PosMax[users.UserModel], users.usMin[users.UserModel], users.usMax[users.UserModel],
                    users.Data); //处理函数

                Valuepass[1] = current(users1.NegMin[users1.UserModel], users1.NegMax[users1.UserModel], users1.PosMin[users1.UserModel],
                   users1.PosMax[users1.UserModel], users1.usMin[users1.UserModel], users1.usMax[users1.UserModel],
                   users1.Data); //处理函数

                Valuepass[2] = current(users2.NegMin[users2.UserModel], users2.NegMax[users2.UserModel], users2.PosMin[users2.UserModel],
                    users2.PosMax[users2.UserModel], users2.usMin[users2.UserModel], users2.usMax[users2.UserModel],
                    users2.Data); //处理函数

                Valuepass[3] = current(users3.NegMin[users3.UserModel], users3.NegMax[users3.UserModel], users3.PosMin[users3.UserModel],
                    users3.PosMax[users3.UserModel], users3.usMin[users3.UserModel], users3.usMax[users3.UserModel],
                    users3.Data); //处理函数

                Valuepass[4] = current(users4.NegMin[users4.UserModel], users4.NegMax[users4.UserModel], users4.PosMin[users4.UserModel],
                    users4.PosMax[users4.UserModel], users4.usMin[users4.UserModel], users4.usMax[users4.UserModel],
                    users4.Data); //处理函数

                Valuepass[5] = current(users5.NegMin[users5.UserModel], users5.NegMax[users5.UserModel], users5.PosMin[users5.UserModel],
                    users5.PosMax[users5.UserModel], users5.usMin[users5.UserModel], users5.usMax[users5.UserModel],
                    users5.Data); //处理函数

                Valuepass[6] = current(users6.NegMin[users6.UserModel], users6.NegMax[users6.UserModel], users6.PosMin[users6.UserModel],
                    users6.PosMax[users6.UserModel], users6.usMin[users6.UserModel], users6.usMax[users6.UserModel],
                    users6.Data); //处理函数

                Valuepass[7] = current(users7.NegMin[users7.UserModel], users7.NegMax[users7.UserModel], users7.PosMin[users7.UserModel],
                    users7.PosMax[users7.UserModel], users7.usMin[users7.UserModel], users7.usMax[users7.UserModel],
                    users7.Data); //处理函数
            }
            else
            {
                Valuepass = null;
            }

            return Valuepass;
        }

        double parameter;
        string parameter2;
        //输入格式为：NegMin   NegMax  PosMin  PosMax usMin usMax
        public string current(double NegMin, double NegMax, double PosMin,
            double PosMax, double usMin, double usMax,
            float Input) //处理函数
        {
            if (Input >= 0x0000
             && Input <= 0x7FFF)
            {
                parameter = Convert.ToSingle(PosMin + ((PosMax - PosMin) * Input) / usMax);
                parameter2 = parameter.ToString("F3");

            }
            else
            {
                parameter = -Convert.ToSingle(PosMin + ((PosMax - PosMin) * (0x10000 - Input)) / (0x10000 - usMax));
                parameter2 = parameter.ToString("F3");
            }

            if (parameter2 == "0.000")
            {
                parameter2 = "0";//"Burn_out";
                return parameter2;
            }
            else
                return parameter2;
        }
        /**********************************************************************/
        public string Calculation(double maxNum, double minNum, float Input)
        {
            double parameter;
            string parameter2;
            parameter = Convert.ToSingle(double.Parse(Input.ToString()) * minNum / maxNum);
            parameter2 = parameter.ToString("F3");
            return parameter2;
        }
        /**********************************************************************/
        string[] text = new string[3];
        public string[] Conversion(UInt16 type, float typedata)//, ushort[] typedata
        {
            switch (type)
            {
                case 0://"V","A_10V"
                    text[0] = Calculation(10.000, -10.000, typedata);
                    text[1] = "V";
                    break;
                case 1://"V","A_5V"
                    text[0] = Calculation(5.000, -5.000, typedata);
                    text[1] = "V";
                    break;

                case 2://"V","A_2_5V"
                    text[0] = Calculation(-2.500, 2.500, typedata);
                    text[1] = "V";
                    break;

                case 3://"V","A_1V"
                    text[0] = Calculation(1, -1, typedata);
                    text[1] = "V";
                    break;

                case 4://"MV","A_500mV"
                    text[0] = Calculation(500.00, -500.00, typedata);
                    text[1] = "MV";
                    break;

                case 5://"MV","A_100mV"
                    text[0] = Calculation(100.00, -100.00, typedata);
                    text[1] = "MV";
                    break;

                case 6://"MV","A_20mV"
                    //text[0] = "MV";
                    text[1] = "MV";
                    break;

                case 7://"℃","T-K"
                    text[0] = Calculation(0x7FFF, 1370.0f, typedata);
                    text[1] = "℃";
                    break;
                case 8://"℃" ,"T-J"
                    text[0] = Calculation(0x7FFF, 7600.0f, typedata);
                    text[1] = "℃";
                    break;
                case 9://"℃" ,"T-R"
                    text[0] = Calculation(0x7FFF, 1750.0f, typedata);
                    text[1] = "℃";
                    break;
                case 10://"℃" ,"T-S"
                    text[0] = Calculation(0x7FFF, 1750.0f, typedata);
                    text[1] = "℃";
                    break;
                case 11://"℃","T-B"
                    text[0] = Calculation(0x7FFF, 1800.0f, typedata);
                    text[1] = "℃";
                    break;
                case 12://"℃" ,"T_E"
                    text[0] = Calculation(0x7FFF, 1000.0d, typedata);
                    text[1] = "℃";
                    break;
                case 13://"℃" ,"T_T"
                    text[0] = Calculation(0x7FFF, 400.0f, typedata);
                    text[1] = "℃";
                    break;
                case 14://"℃" ,"T_N"
                    text[0] = Calculation(0x7FFF, 1800, typedata);
                    text[1] = "℃";
                    break;
                case 15:// "MA","I_0_20mA"
                    text[0] = Calculation(0x7FFF, 1800, typedata);
                    text[1] = "MA";
                    break;
                case 16:// "MA", "I_4_20mA"
                    text[0] = Calculation(0x7FFF, 1800, typedata);
                    text[1] = "MA";
                    break;
                default:
                    MessageBox.Show("我没有这个范围");
                    break;
            }
            /*****************有效判断*****************************/
            if (text[0] == "0.000")
            {
                text[0] = "0";
                return text;
            }
            else
                return text;
            //通过Case做判断并输出一个数组
        }

    }
}
