﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO.Ports;
using System.Linq;
using System.Net.NetworkInformation;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using Modbus.Device;
using MQTTnet;
using MQTTnet.Client;
using Newtonsoft.Json;
using System.IO;
using System.Diagnostics;
using ModbusDemo;
using System.Timers;
namespace ModbusDemo
{
    public partial class Form1 : Form
    {
        bool Debug_test = false;//打开测试功能
        _418X Analog = new _418X();
        _414P rtd = new _414P();
        _478C state = new _478C();
        private bool bStart = false;
        FileStream fsl;
        AutoResetEvent exitEvent;
        private int waitTime;
        private Thread t_UpgradeConn;
        public delegate void invokeDelegate();
        System.Timers.Timer timer = new  System.Timers.Timer();
        System.Timers.Timer MQTTTimer = new System.Timers.Timer();
        ModbusDemo.windows.Totxt totxt = new windows.Totxt(AppDomain.CurrentDomain.BaseDirectory + @"/log/Log.txt");

        public Form1()
        {
            InitializeComponent();

        }
   


        #region 参数
        /// <summary>
        /// 串口变量
        /// </summary>
        SerialPort serialPort;
        string portName;
        int baudRate;
        int dataBits;
        Parity parity;
        StopBits stopBits;
        private SerialPort comPort = new SerialPort();
        ModbusMaster master;



        
        //////////////////////////////////////////////////////////////
        string mqttIp;
        string mqttClientId;
        int mqttPort;
        string mqttUsername;
        string mqttPwd;
        string mqttTopic;
        string mqttSubscribeTopic;
        string mqttSn;
        string mqttData;//数据
        private IMqttClient mqttClient = null;
        private bool isReconnect = true;

        bool[] DI = new bool[10];
        bool[] DO = new bool[10];

        float[] AI = new float[10];
        float[] AO = new float[10];

        #endregion
        private void SetMqtt()
        {
            mqttSn = "20193261";
            mqttTopic = "Witium/WTDS78X/" + mqttSn + "/Data";
            if (Debug_test == true)
            {
                mqttIp = "120.27.235.39";
                mqttClientId = GetTimeStamp() + "sxz";
                mqttPort = 1883;
                mqttUsername = "pasture";
                mqttPwd = "Pasture37774020";
            }
            else
            {
                mqttIp = "47.101.50.24";
                mqttClientId = GetTimeStamp() + "sxz";
                mqttPort = 1883;
                mqttUsername = "root";
                mqttPwd = "public";
            }

        }
        private void SetTopic()
        {
            mqttSn = "20193261";
            mqttSubscribeTopic = "Witium/WTDS78X/" + mqttSn + "/OData";
        }
        #region 时间戳
        /// <summary> 
        /// 获取时间戳 
        /// </summary> 
        /// <returns></returns> 
        public static string GetTimeStamp()
        {
            TimeSpan ts = DateTime.UtcNow - new DateTime(1970, 1, 1, 0, 0, 0, 0);
            return Convert.ToInt64(ts.TotalSeconds).ToString();

        }
        #endregion

        #region 方法

        private void SetPort(string pName, int pbaudRate, int dataBits, Parity pparity, StopBits pstopBits)
        {
            if (serialPort != null)
            {
                serialPort.Dispose();
            }
            serialPort = new SerialPort();
            serialPort.PortName = portName;
            serialPort.BaudRate = baudRate;
            serialPort.DataBits = dataBits;
            serialPort.Parity = parity;
            serialPort.StopBits = stopBits;
        }

        private void OpenPort()
        {
            try
            {
                if (serialPort != null)
                {
                    if (serialPort.IsOpen)
                    {
                        serialPort.Close();
                    }
                    serialPort.Open();
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }

        }

        private void CreateModbusRtu()
        {
            try
            {
                if (serialPort != null)
                {
                    if (serialPort.IsOpen)
                    {
                        master = ModbusSerialMaster.CreateRtu(serialPort);
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }

        //private ushort[] ReadHoldingReg(Modular modular, byte slaveId, ushort startAdd, ushort numPoint)
        private ushort[] ReadHoldingReg(byte slaveId, ushort startAdd, ushort numPoint)
        {
            ushort[] data = new ushort[numPoint];

            data = master.ReadHoldingRegisters(slaveId, startAdd, numPoint);

            return data;
            //switch (modular)
            //{
            //    case Modular.M_WTD414P:
            //        data = master.ReadHoldingRegisters(slaveId, startAdd, numPoint);
            //        break;
            //    case Modular.M_WTD418X:
            //        data = master.ReadHoldingRegisters(slaveId, startAdd, numPoint);
            //        break;
            //    case Modular.M_WTD478C:
            //        break;
            //    default:
            //        break;
            //}
        }

        private byte[] ReadCoilStatus(byte slaveId, ushort startAdd, ushort numPoint)
        {
            byte[] data = new byte[numPoint];

            data = getByte(master.ReadCoils(slaveId, startAdd, numPoint));

            return data;
        }


        public static byte[] getByte(bool[] array)
        {
            byte[] data = new byte[array.Length];
            for (int i = 0; i < array.Length; i++)
            {
                if (array[i])
                    data[i] = 1;
                else
                    data[i] = 0;
            }
            return data;
        }


        #endregion

        #region mqtt服务

        private async Task Publish()
        {
            var message = new MqttApplicationMessageBuilder()
                .WithTopic(mqttTopic)
                .WithPayload(mqttData)
                .WithAtMostOnceQoS()
                .WithRetainFlag(false)
                .Build();   
            await mqttClient.PublishAsync(message);
        }

        private async Task Subscribe()
        {
            if (!mqttClient.IsConnected)
            {
                MessageBox.Show("MQTT客户端尚未连接！");
                return;
            }

            // Subscribe to a topic
            await mqttClient.SubscribeAsync(new TopicFilterBuilder()
                .WithTopic(mqttSubscribeTopic)
                .WithAtMostOnceQoS()
                .Build()
                );

            Invoke((new Action(() =>
            {
                Console.WriteLine("已订阅[{topic}]主题{Environment.NewLine}");

                 txtReceiveMessage.AppendText($"已订阅[{mqttSubscribeTopic}]主题{Environment.NewLine}");
                 totxt.Log($"已订阅[{mqttSubscribeTopic}]主题{Environment.NewLine}");
                //txtReceiveMessage.AppendText($"已订阅[{Data}]主题{Environment.NewLine}");
            })));
        }

        private async Task ConnectMqttServerAsync()
        {
            // Create a new MQTT client.

            if (mqttClient == null)
            {
                var factory = new MqttFactory();
                mqttClient = factory.CreateMqttClient();

                mqttClient.ApplicationMessageReceived += MqttClient_ApplicationMessageReceived;
                mqttClient.Connected += MqttClient_Connected;
                mqttClient.Disconnected += MqttClient_Disconnected;
            }

            //非托管客户端
            try
            {

                //Create TCP based options using the builder.
                var options = new MqttClientOptionsBuilder()
                    .WithClientId(mqttClientId)
                    .WithTcpServer(mqttIp, mqttPort)
                    .WithCredentials(mqttUsername, mqttPwd)
                    //.WithTls()//服务器端没有启用加密协议，这里用tls的会提示协议异常
                    .WithCleanSession()
                    .Build();

                await mqttClient.ConnectAsync(options);
            }
            catch (Exception ex)
            {
                Invoke((new Action(() =>
                {
                    //txtReceiveMessage.AppendText($"连接到MQTT服务器失败！" + Environment.NewLine + ex.Message + Environment.NewLine);
                    Console.WriteLine($"连接到MQTT服务器失败！" + Environment.NewLine + ex.Message + Environment.NewLine);
                    totxt.Log($"连接到MQTT服务器失败！" + Environment.NewLine + ex.Message + Environment.NewLine);
                })));
            }

            //托管客户端
            try
            {

            }
            catch (Exception)
            {

            }
        }

        private void MqttClient_Connected(object sender, EventArgs e)
        {
            Invoke((new Action(() =>
            {
                txtReceiveMessage.Clear();
                txtReceiveMessage.AppendText("已连接到MQTT服务器！" + Environment.NewLine);
                totxt.Log("已连接到MQTT服务器！" + Environment.NewLine);
                //Console.WriteLine("已连接到MQTT服务器！" + Environment.NewLine);
            })));
        }

        private void MqttClient_Disconnected(object sender, EventArgs e)
        {
            Invoke((new Action(() =>
            {
                   txtReceiveMessage.Clear();
                   DateTime curTime = new DateTime();
                   curTime = DateTime.UtcNow;
                   txtReceiveMessage.AppendText($">> [{curTime.ToLongTimeString()}]");
                totxt.Log($">> [{curTime.ToLongTimeString()}]");
                txtReceiveMessage.AppendText("已断开MQTT连接！" + Environment.NewLine);
                totxt.Log("已断开MQTT连接！" + Environment.NewLine);

                //Console.WriteLine("已断开MQTT连接！" + Environment.NewLine);
            })));

            //Reconnecting
            if (isReconnect)
            {
                Invoke((new Action(() =>
                {
                    txtReceiveMessage.AppendText("正在尝试重新连接" + Environment.NewLine);
                    totxt.Log("正在尝试重新连接" + Environment.NewLine);

                    //Console.WriteLine("正在尝试重新连接" + Environment.NewLine);

                })));

                var options = new MqttClientOptionsBuilder()
                    .WithClientId(mqttClientId)
                    .WithTcpServer(mqttIp, mqttPort)
                    .WithCredentials(mqttUsername, mqttPwd)
                    //.WithTls()
                    .WithCleanSession()
                    .Build();
                Invoke((new Action(async () =>
                {
                    await Task.Delay(TimeSpan.FromSeconds(5));
                    try
                    {
                        await mqttClient.ConnectAsync(options);
                    }
                    catch
                    {
                        txtReceiveMessage.AppendText("### RECONNECTING FAILED ###" + Environment.NewLine);
                        totxt.Log("### RECONNECTING FAILED ###" + Environment.NewLine);
                        //Console.WriteLine("### RECONNECTING FAILED ###" + Environment.NewLine);
                    }
                })));
            }
            else
            {
                Invoke((new Action(() =>
                {
                    txtReceiveMessage.AppendText("已下线！" + Environment.NewLine);
                    totxt.Log("已下线！" + Environment.NewLine);
                    //Console.WriteLine("已下线！" + Environment.NewLine);
                })));
            }
        }

        private void MqttClient_ApplicationMessageReceived(object sender, MqttApplicationMessageReceivedEventArgs e)
        {
            Invoke((new Action(() =>
            {
                //收到的消息啦
                txtReceiveMessage.AppendText($">> {"### RECEIVED APPLICATION MESSAGE ###"}{Environment.NewLine}");
                totxt.Log($">> {"### RECEIVED APPLICATION MESSAGE ###"}{Environment.NewLine}");
            })));
            Invoke((new Action(() =>
            {
                //我的订阅主题是。。。。。
                txtReceiveMessage.AppendText($">> Topic = {e.ApplicationMessage.Topic}{Environment.NewLine}");
                totxt.Log($">> Topic = {e.ApplicationMessage.Topic}{Environment.NewLine}");
            })));
            Invoke((new Action(() =>
            {
                //消息的内容
                txtReceiveMessage.AppendText($">> Payload = {Encoding.UTF8.GetString(e.ApplicationMessage.Payload)}{Environment.NewLine}");
                totxt.Log($">> Payload = {Encoding.UTF8.GetString(e.ApplicationMessage.Payload)}{Environment.NewLine}");
                Console.WriteLine(Encoding.UTF8.GetString(e.ApplicationMessage.Payload));
                //订阅内容部分jSON 解析转对象 根据modbusID或者设备类型处理设备消息
                //WTDR14P WTD14P = JsonConvert.DeserializeObject<WTDR14P>(Encoding.UTF8.GetString(e.ApplicationMessage.Payload));
                //WTDR66C WTD66C =JsonConvert.DeserializeObject<WTDR66C>(Encoding.UTF8.GetString(e.ApplicationMessage.Payload));
               //解析控制部分

                //txtReceiveMessage.Clear();
            })));
            Invoke((new Action(() =>
            {
                txtReceiveMessage.AppendText($">> QoS = {e.ApplicationMessage.QualityOfServiceLevel}{Environment.NewLine}");
                totxt.Log($">> QoS = {e.ApplicationMessage.QualityOfServiceLevel}{Environment.NewLine}");
            })));
            Invoke((new Action(() =>
            {
                txtReceiveMessage.AppendText($">> Retain = {e.ApplicationMessage.Retain}{Environment.NewLine}");
                totxt.Log($">> Retain = {e.ApplicationMessage.Retain}{Environment.NewLine}");
            })));
        }
        #endregion

        #region modbus线程（未写完）
        //public static void CallToChildThread()
        //{
        //    Console.WriteLine("Child thread starts");
        //}
        //ManualResetEvent startrt1 = new ManualResetEvent(false);
        //ManualResetEvent startrt2 = new ManualResetEvent(false);

        //Thread rt_GetData1;
        //private void StartReadThread1()
        //{
        //    if (startrt1 != null)
        //    {
        //        startrt1.Reset();
        //    }
        //    rt_GetData1 = new Thread(GeData1);
        //    rt_GetData1.IsBackground = true;
        //    rt_GetData1.Start();
        //}

        //public void GetDataStop1()
        //{
        //    startrt1.Set();
        //}

        //public void GetDataStop()
        //{
        //    this.startrt1.Reset();
        //}

        //private  void GeData1()
        //{
        //    while (!startrt1.WaitOne(60000))
        //    {
        //        //数据类型 新建类
        //        //数据读取 
        //        Modbus_polling();
        //        Thread.Sleep(60000);
        //    }
        //}


        //Thread rt_GetData2;
        //private void StartReadThread2()
        //{
        //    if (startrt2 != null)
        //    {
        //        startrt2.Reset();
        //    }
        //    rt_GetData2 = new Thread(GeData2);
        //    rt_GetData2.IsBackground = true;
        //    rt_GetData2.Start();
        //}

        //public void GetDataStop2()
        //{
        //    startrt2.Set();
        //}

        //private void GeData2()
        //{
        //    while (!startrt2.WaitOne(500))
        //    {
        //        Thread.Sleep(500);
        //    }
        //}
        #endregion

        #region json字符串转对象
        /// <summary>
        /// json字符串转对象
        /// </summary>
        /// <typeparam name="RData">接收的对象</typeparam>
        /// <param name="rd">json字符串</param>
        /// <returns></returns>
        public RData DataConversion<RData>(string rd)
        {
            try
            {
                return JsonConvert.DeserializeObject<RData>(rd);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                return default(RData);
            }
        }
        public UData DataConverion<UData>(string ud)
        {
            try
            {
                return JsonConvert.DeserializeObject<UData>(ud);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                return default(UData);
            }
        }
        /// <summary>
        /// 对象转json字符串
        /// </summary>
        /// <param name="ud">上传实体</param>
        /// <returns></returns>
        public string DataConversion(UData ud)
        {
            try
            {
                return JsonConvert.SerializeObject(ud);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                return "";
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="rD"></param>
        /// <returns></returns>
        public string DataConversion(RData rD)
        {
            try
            {
                return JsonConvert.SerializeObject(rD);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                return "";
            }
        }
        #endregion


        #region 网络检测

        ManualResetEvent network = new ManualResetEvent(false);
        Thread MonitorThread;
        private void StartMonitorThread()
        {
            if (network != null)
            {
                network.Reset();
            }
            MonitorThread = new Thread(MonitorNetWork);
            MonitorThread.IsBackground = true;
            MonitorThread.Start();
        }

        public void MonitorThreadStop()
        {
            network.Set();
        }

        private void MonitorNetWork()
        {
            while (!network.WaitOne(500))
            {
                string url = "www.baidu.com;www.sina.com;www.cnblogs.com;www.google.com;www.163.com;www.csdn.com";
                string[] urls = url.Split(new char[] { ';' });
                CheckServeStatus(urls);
                Thread.Sleep(1000);
            }
        }
        /// <summary>
        /// 检测网络连接状态
        /// </summary>
        /// <param name="urls"></param>
        public static void CheckServeStatus(string[] urls)
        {
            int errCount = 0;//ping时连接失败个数

            if (!LocalConnectionStatus())
            {
                Console.WriteLine("网络异常~无连接");
            }
            else if (!MyPing(urls, out errCount))
            {
                if ((double)errCount / urls.Length >= 0.3)
                {
                    Console.WriteLine("网络异常~连接多次无响应");
                }
                else
                {
                    Console.WriteLine("网络不稳定");
                }
            }
            else
            {
                Console.WriteLine("网络正常");
            }
        }

        private const int INTERNET_CONNECTION_MODEM = 1;
        private const int INTERNET_CONNECTION_LAN = 2;

        [System.Runtime.InteropServices.DllImport("winInet.dll")]
        private static extern bool InternetGetConnectedState(ref int dwFlag, int dwReserved);

        /// <summary>
        /// 判断本地的连接状态
        /// </summary>
        /// <returns></returns>
        private static bool LocalConnectionStatus()
        {
            System.Int32 dwFlag = new Int32();
            if (!InternetGetConnectedState(ref dwFlag, 0))
            {
                Console.WriteLine("LocalConnectionStatus--未连网!");
                return false;
            }
            else
            {
                if ((dwFlag & INTERNET_CONNECTION_MODEM) != 0)
                {
                    Console.WriteLine("LocalConnectionStatus--采用调制解调器上网。");
                    return true;
                }
                else if ((dwFlag & INTERNET_CONNECTION_LAN) != 0)
                {
                    Console.WriteLine("LocalConnectionStatus--采用网卡上网。");
                    return true;
                }
            }
            return false;
        }

        /// <summary>
        /// Ping命令检测网络是否畅通
        /// </summary>
        /// <param name="urls">URL数据</param>
        /// <param name="errorCount">ping时连接失败个数</param>
        /// <returns></returns>
        public static bool MyPing(string[] urls, out int errorCount)
        {
            bool isconn = true;
            Ping ping = new Ping();
            errorCount = 0;
            try
            {
                PingReply pr;
                for (int i = 0; i < urls.Length; i++)
                {
                    pr = ping.Send(urls[i]);
                    if (pr.Status != IPStatus.Success)
                    {
                        isconn = false;
                        errorCount++;
                    }
                    Console.WriteLine("Ping " + urls[i] + "    " + pr.Status.ToString());
                }
            }
            catch
            {
                isconn = false;
                errorCount = urls.Length;
            }
            //if (errorCount > 0 && errorCount < 3)
            //  isconn = true;
            return isconn;
        }

        #endregion


        private void Form1_Load(object sender, EventArgs e)
        {
            cmbBaud.SelectedIndex = 7;
            cmbDataBit.SelectedIndex = 1;
            cmbParity.SelectedIndex = 0;
            cmbStopBit.SelectedIndex = 0;
            foreach (string s in SerialPort.GetPortNames())
            cmbPort.Items.Add(s);
            cmbPort.SelectedIndex = -1;

            exitEvent = new AutoResetEvent(false);
            waitTime = 6000;
            t_UpgradeConn = new Thread(UpgradeProc);
            t_UpgradeConn.IsBackground = true;
            t_UpgradeConn.Start();
        }
        
        private void GetData()
        {
            timer.Interval = 6000;
            timer.Enabled = true;
            timer.AutoReset = true;//设置是执行一次（false）还是一直执行(true)；  
            timer.Start();
            timer.Elapsed += (o, a) =>
            {
                SetData();
                ShowMessage(string.Format("更新时间：" + DateTime.Now));
            };
        }
        private  void Sendout()
        {
            Control.CheckForIllegalCrossThreadCalls = false;
            MQTTTimer.Interval = 1000;
            MQTTTimer.Enabled = true;
            MQTTTimer.AutoReset = true;//设置是执行一次（false）还是一直执行(true)；  
            MQTTTimer.Start();
            MQTTTimer.Elapsed += async (o, a) =>
            {
                try
                {
                    await Publish();
                    totxt.Log(mqttData + Environment.NewLine + "\n");
                    txtReceiveMessage.AppendText(mqttData + Environment.NewLine + "\n");
                }
                catch (Exception ex)
                {
                    ShowMessage(string.Format("更新时间：" + DateTime.Now));
                    totxt.Log(ex + "," + Environment.NewLine + "\n");
                    return;
                    //throw ex;
                }
            };
        }

        //声明委托
        private delegate void SetDataDelegate();
        private void SetData()
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new SetDataDelegate(SetData));
            }
            else
            {
                Modbus_polling();
            }
        }

        //声明委托
        private delegate void ShowMessageDelegate(string message);
        private void ShowMessage(string message)
        {
            if (this.InvokeRequired)
            {
                ShowMessageDelegate showMessageDelegate = ShowMessage;
                this.Invoke(showMessageDelegate, new object[] { message });
            }
            else
            {
                //txtbox.Text = message;
                totxt.Log(message);
            }
        }

        private void btOpenCOM_Click(object sender, EventArgs e)
        {
            if (Debug_test == true)
            {
                comPort.PortName = "COM1";
                comPort.BaudRate = 9600;
                comPort.Parity = Parity.None;
                comPort.StopBits = StopBits.One;
                comPort.DataBits = 8;
            }
            else
            {
                if (cmbPort.Text == "")
                {
                    MessageBox.Show("串口打开错误");
                    return;
                }
                comPort.PortName = cmbPort.Text;
                comPort.BaudRate = int.Parse(cmbBaud.Text);
                comPort.DataBits = int.Parse(cmbDataBit.Text);
                if (cmbParity.Text.Substring(0, 1) == "0")
                {
                    comPort.Parity = Parity.None;
                }
                else if (cmbParity.Text.Substring(0, 1) == "1")
                {
                    comPort.Parity = Parity.Odd;
                }
                else if (cmbParity.Text.Substring(0, 1) == "2")
                {
                    comPort.Parity = Parity.Even;
                }
                if (cmbStopBit.Text == "0")
                {
                    comPort.StopBits = StopBits.None;
                }
                else if (cmbStopBit.Text == "1")
                {
                    comPort.StopBits = StopBits.One;
                }
            }
            try
            {
                comPort.Open();
                isReconnect = true;
                SetMqtt();
                Thread t = new Thread(new ThreadStart(GetData));
                t.IsBackground = true;
                t.Start();
                Thread MQTT_thread = new Thread(new ThreadStart(Sendout));
                MQTT_thread.IsBackground = true;
                MQTT_thread.Start();
                Task.Run(async () => { await ConnectMqttServerAsync(); });
                master =ModbusSerialMaster.CreateRtu(comPort);
                master.Transport.Retries = 6;   //重试次数
                master.Transport.ReadTimeout = 1500; //读取串口数据超时时间(ms)
                master.Transport.WriteTimeout = 1500;//写入串口数据超时时间(ms)
                master.Transport.WaitToRetryMilliseconds = 500;//重试间隔(ms)
                modbus_Timer.Enabled = true;
                btOpenCOM.Enabled = false;
                btCloseCOM.Enabled = true;
                totxt.Log(DateTime.Now.ToString() + " =>Open " + comPort.PortName + " sucessfully!");
            }
            catch (Exception ex)
            {
                totxt.Log("Error: " + ex.Message);
                MessageBox.Show("Error: " + ex.Message);
                return;
            }
        }

        private void btCloseCOM_Click(object sender, EventArgs e)
        {
            //Close comport first,then stop and dispose slave.  
            timer.Stop();
            isReconnect = false;
            modbus_Timer.Enabled = false;
            btOpenCOM.Enabled = true;
            btCloseCOM.Enabled = false;
            Task.Run(async () => { await mqttClient.DisconnectAsync(); });
            comPort.Close();
            totxt.Log(DateTime.Now.ToString() + " =>Disconnect " + comPort.PortName);
        }

        public void Modbus_ReadHoldingRegistersTask(out ushort[] OutputValue, byte slaveAddress , ushort startAddress, ushort numberOfPoints, out int Caution)
        {
            try
            {
                OutputValue = master.ReadHoldingRegisters(slaveAddress, startAddress, numberOfPoints);
                Caution = 0;
            }
            catch (Exception exception)
            {
                //Connection exception
                //No response from server.
                //The server maybe close the com port, or response timeout.
                if (exception.Source.Equals("System"))
                {
                    timer.Stop();
                    Console.WriteLine(DateTime.Now.ToString() + " " + exception.Message);
                    totxt.Log(DateTime.Now.ToString() + " " + exception.Message);
                    OutputValue = null;
                    Caution = -1;
                }
                //The server return error code.
                //You can get the function code and exception code.
                if (exception.Source.Equals("nModbusPC"))
                {
                    string str = exception.Message;
                    int FunctionCode;
                    string ExceptionCode;

                    str = str.Remove(0, str.IndexOf("\r\n") + 17);
                    FunctionCode = Convert.ToInt16(str.Remove(str.IndexOf("\r\n")));
                    Console.WriteLine("Function Code: " + FunctionCode.ToString("X"));
                    totxt.Log("Function Code: " + FunctionCode.ToString("X"));

                    str = str.Remove(0, str.IndexOf("\r\n") + 17);
                    ExceptionCode = str.Remove(str.IndexOf("-"));
                    switch (ExceptionCode.Trim())
                    {
                        case "1":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal function!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> Illegal function!");
                            break;
                        case "2":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data address!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data address!");
                            break;
                        case "3":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data value!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data value!");
                            break;
                        case "4":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Slave device failure!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> Slave device failure!");
                            break;
                        case "5":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> ACKNOWLEDGE!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> ACKNOWLEDGE!");
                            break;
                        case "6":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> SLAVE DEVICE BUSY !");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> SLAVE DEVICE BUSY !");
                            break;
                        case "8":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> MEMORY PARITY ERROR !");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> MEMORY PARITY ERROR !");
                            break;
                        case "A":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> GATEWAY PATH UNAVAILABLE !");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> GATEWAY PATH UNAVAILABLE !");
                            break;
                        case "B":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "---->GATEWAY TARGET DEVICE FAILED TO RESPOND!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "---->GATEWAY TARGET DEVICE FAILED TO RESPOND!");
                            break;
                    }
                }
                OutputValue = null;
                Caution = -1;
            }
        }
        public void Modbus_ReadCoilsTask(out bool  [] OutputValue, byte slaveAddress, ushort startAddress, ushort numberOfPoints, out int Caution)
        {
            try
            {
                OutputValue = master.ReadCoils(slaveAddress, startAddress, numberOfPoints);
                Caution = 0;
            }
            catch (Exception exception)
            {
                //Connection exception
                //No response from server.
                //The server maybe close the com port, or response timeout.
                if (exception.Source.Equals("System"))
                {
                    timer.Stop();
                    Console.WriteLine(DateTime.Now.ToString() + " " + exception.Message);
                    totxt.Log(DateTime.Now.ToString() + " " + exception.Message);
                    OutputValue = null;
                    Caution = -1;
                }
                //The server return error code.
                //You can get the function code and exception code.
                if (exception.Source.Equals("nModbusPC"))
                {
                    string str = exception.Message;
                    int FunctionCode;
                    string ExceptionCode;

                    str = str.Remove(0, str.IndexOf("\r\n") + 17);
                    FunctionCode = Convert.ToInt16(str.Remove(str.IndexOf("\r\n")));
                    Console.WriteLine("Function Code: " + FunctionCode.ToString("X"));
                    totxt.Log("Function Code: " + FunctionCode.ToString("X"));

                    str = str.Remove(0, str.IndexOf("\r\n") + 17);
                    ExceptionCode = str.Remove(str.IndexOf("-"));
                    switch (ExceptionCode.Trim())
                    {
                        case "1":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal function!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> Illegal function!");
                            break;
                        case "2":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data address!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data address!");
                            break;
                        case "3":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data value!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data value!");
                            break;
                        case "4":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Slave device failure!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> Slave device failure!");
                            break;
                        case "5":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> ACKNOWLEDGE!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> ACKNOWLEDGE!");
                            break;
                        case "6":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> SLAVE DEVICE BUSY !");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> SLAVE DEVICE BUSY !");
                            break;
                        case "8":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> MEMORY PARITY ERROR !");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> MEMORY PARITY ERROR !");
                            break;
                        case "A":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> GATEWAY PATH UNAVAILABLE !");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> GATEWAY PATH UNAVAILABLE !");
                            break;
                        case "B":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "---->GATEWAY TARGET DEVICE FAILED TO RESPOND!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "---->GATEWAY TARGET DEVICE FAILED TO RESPOND!");
                            break;
                    }
                }
                OutputValue = null;
                Caution = -1;
            }
        }
        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            System.Environment.Exit(0);
        }
        
        private  void Modbus_polling()
        {
           
            float EastTemperature = 0;
            float Easternwaterlevel = 0;
            float WestWaterLevel = 0;
            try
            {
               
                ushort[] temperature = {};
                ushort[] type = { };
                string[] vs = {};
                string[] s = { };
                string[] s6 = { };
                ushort[] register = { };
                ushort[] Inputtype = { };
                ushort[] registerN = { };
                ushort[] InputtypeN = { };
                bool[] EIO = { };
                bool[] SIO = { };
                bool[] WIO = { };
                int[] EOnOff = {0};
                int[] SOnOff = {0};
                int[] WOnOff = {0};
                Modbus_ReadHoldingRegistersTask(out temperature, 1, 0, 4, out int signT);
                Modbus_ReadHoldingRegistersTask(out type,1,10,4,out int sign);
                Modbus_ReadHoldingRegistersTask(out register, 3, 0, 8, out int signr);
                Modbus_ReadHoldingRegistersTask(out Inputtype, 3, 10, 8, out int signI);
                Modbus_ReadHoldingRegistersTask(out registerN, 6, 0, 8, out int signre);
                Modbus_ReadHoldingRegistersTask(out InputtypeN, 6, 10, 8, out int signIn);
                Modbus_ReadCoilsTask(out EIO, 5, 16, 6,out int signE);
                Modbus_ReadCoilsTask(out SIO, 8, 16, 6, out int signS);
                Modbus_ReadCoilsTask(out WIO, 4, 16, 6, out int signW);

                if (sign == -1 || signT ==-1||signr==-1||signI == -1|| signre==-1|| signIn==-1||signE==-1||signS==-1|| signW ==-1)
                {

                    vs = null ;
                    type = null;
                    EastTemperature = 0;
                    Easternwaterlevel = 0;
                    WestWaterLevel = 0 ;
                }
                else
                {
                  vs = rtd.RtdValue(temperature, type);
                  EastTemperature =float.Parse(vs[0]);
                  s = Analog.Value(register, Inputtype);
                  Easternwaterlevel = (float.Parse(s[0]) - 4) / 16 * 6;
                  s6 = Analog.Value(registerN, InputtypeN);
                  WestWaterLevel = (float.Parse(s6[0]) - 4) / 16 * 6;
                  label3.Text = EastTemperature.ToString();
                  label4.Text = Easternwaterlevel.ToString();
                  EOnOff = state.IO(EIO);////东中转池   
                  SOnOff = state.IO(SIO);////东南北水
                  WOnOff = state.IO(WIO); ////西中转池
                }

               

                WTDR14P x = new WTDR14P("1", EastTemperature, 0, 0, 0, GetTimeStamp());
                WTDR18X p = new WTDR18X("3", Easternwaterlevel, 0, 0, 0, 0, 0, 0, 0, GetTimeStamp());
                WTDR18X q = new WTDR18X("6", WestWaterLevel, 0, 0, 0, 0, 0, 0, 0, GetTimeStamp());

                //东搅拌
                WTDR66C EastStir = new WTDR66C("5", EOnOff[0], EOnOff[1], EOnOff[2], EOnOff[3], EOnOff[4], EOnOff[5], GetTimeStamp());
                //西搅拌
                WTDR66C WestStir = new WTDR66C("8", WOnOff[0], WOnOff[1], WOnOff[2], WOnOff[3], WOnOff[4], WOnOff[5], GetTimeStamp());
                //东南北水
                WTDR66C SouthWater = new WTDR66C("4", SOnOff[0], SOnOff[1], SOnOff[2], SOnOff[3], SOnOff[4], SOnOff[5], GetTimeStamp());

                mqttData = "[" +
                    JsonConvert.SerializeObject(x)+"," +
                   JsonConvert.SerializeObject(p)+"," +
                   JsonConvert.SerializeObject(q) +","+
                   JsonConvert.SerializeObject(EastStir)+","+
                    JsonConvert.SerializeObject(WestStir) + "," +
                     JsonConvert.SerializeObject(SouthWater)
                    + "]";

                //txtReceiveMessage.AppendText("["+
                //    JsonConvert.SerializeObject(x)+","+
                //    JsonConvert.SerializeObject(p) +","+
                //    JsonConvert.SerializeObject(q) + "," +
                //    JsonConvert.SerializeObject(EastStir) + "," +
                //    JsonConvert.SerializeObject(WestStir) + "," +
                //     JsonConvert.SerializeObject(SouthWater)
                //    + "]" + Environment.NewLine + "\n");

                //totxt.Log("[" +
                //    JsonConvert.SerializeObject(x) + "," +
                //    JsonConvert.SerializeObject(p) + "," +
                //    JsonConvert.SerializeObject(q) + "," +
                //    JsonConvert.SerializeObject(EastStir) + "," +
                //    JsonConvert.SerializeObject(WestStir) + "," +
                //     JsonConvert.SerializeObject(SouthWater)
                //    + "]" + Environment.NewLine + "\n");

               
            }

            catch (Exception exception)
            {
                //Connection exception
                //No response from server.
                //The server maybe close the com port, or response timeout.
                if (exception.Source.Equals("System"))
                {
                    timer.Stop();
                    Console.WriteLine(DateTime.Now.ToString() + " " + exception.Message);
                    totxt.Log(DateTime.Now.ToString() + " " + exception.Message);
                    return;
                }
                //The server return error code.
                //You can get the function code and exception code.
                if (exception.Source.Equals("nModbusPC"))
                {
                    string str = exception.Message;
                    int FunctionCode;
                    string ExceptionCode;

                    str = str.Remove(0, str.IndexOf("\r\n") + 17);
                    FunctionCode = Convert.ToInt16(str.Remove(str.IndexOf("\r\n")));
                    Console.WriteLine("Function Code: " + FunctionCode.ToString("X"));
                    totxt.Log("Function Code: " + FunctionCode.ToString("X"));
                    //MessageBox.Show("Function Code: " + FunctionCode.ToString("X"));

                    str = str.Remove(0, str.IndexOf("\r\n") + 17);
                    ExceptionCode = str.Remove(str.IndexOf("-"));
                    switch (ExceptionCode.Trim())
                    {
                        case "1":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal function!");
                            //MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> Illegal function!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> Illegal function!");
                            break;
                        case "2":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data address!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data address!");
                            //MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data address!");
                            break;
                        case "3":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data value!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data value!");
                            //MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data value!");
                            break;
                        case "4":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Slave device failure!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> Slave device failure!");
                            //MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> Slave device failure!");
                            break;
                        case "5":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> ACKNOWLEDGE!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> ACKNOWLEDGE!");
                            //MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> ACKNOWLEDGE!");
                            break;
                        case "6":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> SLAVE DEVICE BUSY !");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> SLAVE DEVICE BUSY !");
                            //MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> SLAVE DEVICE BUSY !");
                            break;
                        case "8":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> MEMORY PARITY ERROR !");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> MEMORY PARITY ERROR !");
                            //MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> MEMORY PARITY ERROR !");
                            break;
                        case "A":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> GATEWAY PATH UNAVAILABLE !");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "----> GATEWAY PATH UNAVAILABLE !");
                            //MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> GATEWAY PATH UNAVAILABLE !");
                            break;
                        case "B":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "---->GATEWAY TARGET DEVICE FAILED TO RESPOND!");
                            totxt.Log("Exception Code: " + ExceptionCode.Trim() + "---->GATEWAY TARGET DEVICE FAILED TO RESPOND!");
                            //MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> GATEWAY TARGET DEVICE FAILED TO RESPOND!");
                            break;
                    }
                    return;
                }
            }
            return;
        }

        #region 更新线程
        string ImagefilePath = null;
        private void bgWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            this.upgrade();
        }
        private void bgWorker_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            UpdateBar.Value = e.ProgressPercentage;
        }
        private void choosebth_Click(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Multiselect = false;//该值确定是否可以选择多个文件
            dialog.Title = "请选择文件夹";
            dialog.Filter = "镜像文件(*.bin)|*.bin";
            if (dialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                string file = dialog.FileName;
                this.ImagefilePath = file;
                if (file.Substring(file.LastIndexOf("\\") + 1).Length > 20)
                {
                    string str = ((file.Substring(file.LastIndexOf("\\") + 1)).Substring(0, 10));
                    this.imagesname.Text = str + "******";
                }
                else
                    this.imagesname.Text = file.Substring(file.LastIndexOf("\\") + 1);


            }
        }
        private void UpdateBtn_Click(object sender, EventArgs e)
        {
            bStart = true;
            int iMaxBufSize = 1024 * 100;
            this.UpdateBtn.Enabled = false;
            this.choosebth.Enabled = false;
            int iFileSize = 0;
            Byte[] FileBuf = new Byte[iMaxBufSize];

            if (ImagefilePath != null)
            {
                FileStream fsl = File.Open(ImagefilePath, FileMode.Open, FileAccess.ReadWrite);
                if (File.Exists(ImagefilePath) == true)
                {
                    BinaryReader br = new BinaryReader(fsl);

                    FileBuf = br.ReadBytes(iMaxBufSize);

                    iFileSize = FileBuf.Length;

                    br.Close();
                    fsl.Close();
                }
            }
            else
            {
                MessageBox.Show("程序不存在");
                this.UpdateBtn.Enabled = true;
                this.choosebth.Enabled = true;
            }

            UpdateBar.Maximum = iFileSize;
            UpdateBar.Minimum = 0;


            if (bStart == true)
            {
                this.bgWorker.WorkerReportsProgress = true;
                this.bgWorker.RunWorkerAsync();
                bStart = false;
            }
            else
            {
                this.bgWorker.WorkerReportsProgress = false;
            }
        }
        private void UpgradeProc()
        {
            while (true)
            {
                if (exitEvent.WaitOne(waitTime))
                {
                    break;
                }
                invokeDelegate setText = () =>
                {
                    if (this.UpdateBar.Value == this.UpdateBar.Maximum)
                    {
                        MessageBox.Show("更新成功！");
                        this.UpdateBar.Value = this.UpdateBar.Minimum;
                        this.UpdateBtn.Enabled = false;
                        this.choosebth.Enabled = true;
                    }
                };
                Invoke(setText);
            }
        }
        private void upgrade()
        {
            //CheckForIllegalCrossThreadCalls = false;
            ////设置CheckForIllegalCrossThreadCalls = false 是能去掉这个检查的,但是这不是标准的作法.
            ////标准的作法是在访问界面控件时,访问下窗体的 InvokeRequired 属性,如果为false就可以直接访问,
            ////否则就是跨线程访问; 此时,创建一个delegate,并通过Invoke() 来调用它.
            ////参考https://www.cnblogs.com/janghe/p/7874889.html

            const int Singlepackage = 100;
            const int PerBlockPacket = Singlepackage;
            const int MB_ENOERR = 0;
            int iFileSizeNow = 0;
            int iFileSize = 0;
            int iMaxBufSize = 1024 * 100;
            ushort[] istage = new ushort[2];
            //ushort[] data = new ushort[2];

            Byte[] FileBuf = new Byte[iMaxBufSize];
            string strLog = "";
            UInt16 u16DevStatus = 0;
            ushort[] usTrans = new ushort[Singlepackage];

            UInt16[] u16unlock = { 0x5749, 0x5449, 0x554D };
            int ret;
            int errCnt = 0;

            FileStream fsl = File.Open(ImagefilePath, FileMode.Open, FileAccess.ReadWrite);
            if (File.Exists(ImagefilePath) == true)
            {
                BinaryReader br = new BinaryReader(fsl);

                FileBuf = br.ReadBytes(iMaxBufSize);

                iFileSize = FileBuf.Length;

                br.Close();
                fsl.Close();
            }
            else
            {
                MessageBox.Show("程序不存在");
            }



            istage[0] = 0;

            master.WriteSingleRegister(1, 20600, 0);

            ushort[] usFileBuf = new ushort[iMaxBufSize];
            Buffer.BlockCopy(FileBuf, 0, usFileBuf, 0, FileBuf.Length);
            bgWorker.ReportProgress(0);
            while (true)
            {
                try
                {
                    ushort[] data = master.ReadHoldingRegisters(1, 20600, 1);
                    u16DevStatus = data[0];
                    int sent = istage[0] * (Singlepackage * 2);

                    strLog = sent.ToString() + " has been sent.";
                    // UpdateBar.Value = sent;
                    bgWorker.ReportProgress(sent);

                    if (u16DevStatus == istage[0])
                    {

                    }
                    else
                    {
                        continue;
                    }

                    if (iFileSizeNow + PerBlockPacket * 2 <= iFileSize)
                    {
                        Buffer.BlockCopy(usFileBuf, iFileSizeNow, usTrans, 0, Singlepackage * 2);
                        try
                        {
                            master.WriteMultipleRegisters(1, 20480, usTrans);
                            istage[0]++;
                            iFileSizeNow += PerBlockPacket * 2;
                            //Thread.Sleep(10);
                        }
                        catch (Exception exception)
                        {
                            //Connection exception
                            //No response from server.
                            //The server maybe close the com port, or response timeout.
                            if (exception.Source.Equals("System"))
                            {
                                if (errCnt > 5)
                                    return;
                                else
                                    errCnt++;

                                Console.WriteLine(DateTime.Now.ToString() + " " + exception.Message);
                                MessageBox.Show(DateTime.Now.ToString() + " " + exception.Message);
                                this.UpdateBar.Value = this.UpdateBar.Minimum;
                                //this.StartTest.Enabled = false;
                                //this.reset.Enabled = false;
                                this.UpdateBtn.Enabled = false;
                                this.choosebth.Enabled = false;
                                return;
                            }
                        }

                    }
                    else
                    {
                        //最后一帧
                        Array.Clear(usTrans, 0, usTrans.Length);
                        Buffer.BlockCopy(usFileBuf, iFileSizeNow, usTrans, 0, iFileSize - iFileSizeNow);
                        try
                        {
                            master.WriteMultipleRegisters(1, 20480, usTrans);
                            istage[0]++;
                            iFileSizeNow += PerBlockPacket * 2;
                            istage[0] = 0x5754;
                            bgWorker.ReportProgress(iFileSize);
                            while (true)
                            {
                                //ret = mb_dev.WriteMultipleRegs(wtdslaveid, 2173, 3, "", 502, ref u16unlock);
                                try
                                {
                                    master.WriteMultipleRegisters(1, 20601, u16unlock);
                                    break;
                                }
                                catch (Exception exception)
                                {
                                    //Connection exception
                                    //No response from server.
                                    //The server maybe close the com port, or response timeout.
                                    if (exception.Source.Equals("System"))
                                    {
                                        Console.WriteLine(DateTime.Now.ToString() + " " + exception.Message);
                                        MessageBox.Show(DateTime.Now.ToString() + " " + exception.Message);
                                        this.UpdateBar.Value = this.UpdateBar.Minimum;
                                        //this.StartTest.Enabled = false;
                                        //this.reset.Enabled = false;
                                        this.UpdateBtn.Enabled = false;
                                        this.choosebth.Enabled = false;
                                        return;
                                    }
                                }

                            }
                            return;
                        }
                        catch (Exception exception)
                        {
                            //Connection exception
                            //No response from server.
                            //The server maybe close the com port, or response timeout.
                            if (exception.Source.Equals("System"))
                            {
                                if (errCnt > 5)
                                    return;
                                else
                                    errCnt++;

                                Console.WriteLine(DateTime.Now.ToString() + " " + exception.Message);
                                MessageBox.Show(DateTime.Now.ToString() + " " + exception.Message);
                                this.UpdateBar.Value = this.UpdateBar.Minimum;
                                //this.StartTest.Enabled = false;
                                //this.reset.Enabled = false;
                                this.UpdateBtn.Enabled = false;
                                this.choosebth.Enabled = false;
                                return;
                            }
                        }
                    }

                }
                catch (Exception exception)
                {
                    //Connection exception
                    //No response from server.
                    //The server maybe close the com port, or response timeout.
                    if (exception.Source.Equals("System"))
                    {
                        if (errCnt > 5)
                            return;
                        else
                            errCnt++;

                        Console.WriteLine(DateTime.Now.ToString() + " " + exception.Message);
                        MessageBox.Show(DateTime.Now.ToString() + " " + exception.Message);
                        this.UpdateBar.Value = this.UpdateBar.Minimum;
                        //this.StartTest.Enabled = false;
                        //this.reset.Enabled = false;
                        this.UpdateBtn.Enabled = false;
                        this.choosebth.Enabled = false;
                        return;
                    }
                    //The server return error code.
                    //You can get the function code and exception code.
                    if (exception.Source.Equals("nModbusPC"))
                    {
                        string str = exception.Message;
                        int FunctionCode;
                        string ExceptionCode;

                        str = str.Remove(0, str.IndexOf("\r\n") + 17);
                        FunctionCode = Convert.ToInt16(str.Remove(str.IndexOf("\r\n")));
                        Console.WriteLine("Function Code: " + FunctionCode.ToString("X"));
                        MessageBox.Show("Function Code: " + FunctionCode.ToString("X"));

                        str = str.Remove(0, str.IndexOf("\r\n") + 17);
                        ExceptionCode = str.Remove(str.IndexOf("-"));
                        switch (ExceptionCode.Trim())
                        {
                            case "1":
                                Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal function!");
                                MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> Illegal function!");
                                break;
                            case "2":
                                Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data address!");
                                MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data address!");
                                break;
                            case "3":
                                Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data value!");
                                MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data value!");
                                break;
                            case "4":
                                Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Slave device failure!");
                                MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> Slave device failure!");
                                break;

                        }
                        this.UpdateBar.Value = this.UpdateBar.Minimum;
                        this.UpdateBtn.Enabled = false;
                        this.choosebth.Enabled = true;
                        return;
                    }
                }
            }
        }
        #endregion


        private void txtReceiveMessage_TextChanged(object sender, EventArgs e)
        {
            if (txtReceiveMessage.TextLength > 3000)
            {
                txtReceiveMessage.Text = "0";
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Modbus_polling();
        }

        private async void SubscribeBut_Click(object sender, EventArgs e)
        {
            SetTopic();
            await Subscribe();
        }
    }


}
